<?php // $Id: index.php,v 1.4.8.2 2007/10/19 08:15:14 joseph_rezeau Exp $

/// This page lists all the instances of portfolio in a particular course


    require_once("../../config.php");
    require_once("lib.php");

    $id = required_param('id', PARAM_INT);

    if (! $course = get_record("course", "id", $id)) {
        error(get_string('incorrectcourseid', 'portfolio'));
    }

    require_login($course->id);

    add_to_log($course->id, "portfolio", "view all", "index.php?id=$course->id", "");


/// Get all required strings

    $strportfolios = get_string("modulenameplural", "portfolio");
    $strportfolio  = get_string("modulename", "portfolio");


/// Print the header

    if ($course->id != SITEID) {
        $navigation = "<a href=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</a> ->";
    } else {
        $navigation = '';
    }

    print_header("$course->shortname: $strportfolios", "$course->fullname", "$navigation $strportfolios", "", "", true, "", navmenu($course));

/// Get all the appropriate data

    if (! $portfolios = get_all_instances_in_course("portfolio", $course)) {
        notice("There are no portfolios", "../../course/view.php?id=$course->id");
        die;
    }

/// Print the list of instances (your module will probably extend this)

    $timenow = time();
    $strname  = get_string("name");
    $strsummary = get_string("summary");
    $strtype = get_string('type', 'portfolio');

    $table->head  = array ($strname, $strsummary, $strtype);
    $table->align = array ("LEFT", "LEFT", 'CENTER');

    foreach ($portfolios as $portfolio) {
        $realm = get_field('portfolio_survey', 'realm', 'id', $portfolio->id);
        // template surveys should NOT be displayed as an activity to students
        if (!($realm == 'template' && isstudent($course->id))) {
            if (!$portfolio->visible) {
                //Show dimmed if the mod is hidden
                $link = "<a class=\"dimmed\" href=\"view.php?id=$portfolio->coursemodule\">$portfolio->name</a>";
            } else {
                //Show normal if the mod is visible
                $link = "<a href=\"view.php?id=$portfolio->coursemodule\">$portfolio->name</a>";
            }
    
            $qtype = get_field('portfolio_survey', 'realm', 'id', $portfolio->sid);
            $table->data[] = array ($link, $portfolio->summary, $qtype);
        }
    }

    echo "<br />";

    print_table($table);

/// Finish the page

    print_footer($course);

?>
