<?php  // $Id: manage_survey.php,v 1.17.8.6 2007/11/18 14:55:32 joseph_rezeau Exp $
/// This page prints a particular instance of portfolio

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/portfolio/lib.php');

    global $errstr;

    $errstr = '';

    $courseid = optional_param('course', NULL, PARAM_INT);        // course ID - if new
    $instance = optional_param('instance', NULL, PARAM_INT);    // portfolio ID - if update
    $section = optional_param('section', NULL, PARAM_INT);
    $qact = optional_param('qact', 'unknown');
    $sid = optional_param('sid', 0, PARAM_INT);              // Survey id.
    $tempsid = $sid; // this is needed for Preview cases later on

    if (!empty($courseid)) {
        if (! $c_obj = get_record('course', 'id', $courseid)) {
            error(get_string('misconfigured', 'portfolio'));
        }
    } 

    $course->lang = $c_obj->lang; //fix for forced language in course
        
    if (!empty($instance)) {
        if (! $portfolio = get_record("portfolio", "id", $instance)) {
            error(get_string('incorrectportfolio', 'portfolio'));
        }
        if (!isset($c_obj)) {
            if (! $c_obj = get_record("course", "id", $portfolio->course)) {
            error(get_string('misconfigured', 'portfolio'));
            }
        }
    }
    if (isset($portfolio) && isset($c_obj)) {
        if (! $cm = get_coursemodule_from_instance("portfolio", $portfolio->id, $c_obj->id)) {
            error(get_string('incorrectmodule', 'portfolio'));
        }
    }

    require_login($c_obj->id);

    if (!isteacheredit($c_obj->id)) {
        error(get_string('restrictedtoteacher', 'portfolio'));
    }
    
    $formdata = data_submitted('nomatch');

    if (!isset($formdata->sid)) {
        if (empty($sid) && !empty($SESSION->portfolio_survey_id)) {
            $formdata->sid = $sid = $SESSION->portfolio_survey_id;
        } else {
            $formdata->sid = 0;
        }
    }
    if (!isset($formdata->summary)) {
        $formdata->summary = '';
    }

    /// If creating a new one, this'll be empty.
    if (empty($portfolio)) {
        $portfolio->id = 0;
        $portfolio->sid = clean_param($formdata->sid, PARAM_INT);
    }

    if (!isset($c_obj)) {
        $c_obj = false;
    }
    if (!isset($cm)) {
        $cm = false;
    }

    $portfolio = new portfolio(0, $portfolio, $c_obj, $cm);
    $tab = 'general';

    if (isset($SESSION->portfolio_tab)) {
        $formdata->tab = $SESSION->portfolio_tab;
        unset($SESSION->portfolio_tab);
    }
    $byresponse = false;
    if (isset($formdata)) {
        $cancancel = false;
        if (!isset($formdata->tab)) {
            $formdata->tab = $tab;
        }
    /// QACTION comes from portfolio/mod.html
        if (isset($formdata->qaction)) {
        /// If this was submitted from the module form, save the data in the SESSION variable.
        /// This is used by '/course/mod.php'.

            /// Need to create the open and close dates...
            if (!empty($formdata->useopendate)) {
                $formdata->opendate =
                    make_timestamp($formdata->openyear, $formdata->openmonth, $formdata->openday,
                                   $formdata->openhour, $formdata->openminute, 0);
            } else {
                $formdata->opendate = 0;
            }
            if (!empty($formdata->useclosedate)) {
                $formdata->closedate =
                    make_timestamp($formdata->closeyear, $formdata->closemonth, $formdata->closeday,
                                   $formdata->closehour, $formdata->closeminute, 0);
            } else {
                $formdata->closedate = 0;
            }
            // automatically naming default portfolio
            $formdata->name = stripslashes($formdata->name);
            if (!$formdata->name) {
                $formdata->name = 'portfolio';
            }
            // JR to see portfolio name in report "add" Info field
            /// This can't go here -- we don't have the $cm yet.
//            add_to_log($course->id, 'portfolio', "add",
//                           "view.php?id=$cm->id",
//                           "$formdata->name", $cm->id);
            $SESSION->modform = $formdata;
            /// If this is a new survey, check how it's created.
            if (isset($formdata->create)) {
                $create = explode('-', $formdata->create);
                if ($create['0'] == 'public') {
                    $formdata->sid = $sid = (int)$create[1];
                    $qact = 'close';
                } else if ($create['0'] == 'template') {
                    $formdata->sid = $sid = (int)$create[1];
                    $qact = 'copy';
                } else {
                    unset($SESSION->portfolio_survey_id);
                    $qact = 'new';
                }
            } else {
                $SESSION->portfolio_survey_id = $formdata->sid;
                $qact = 'edit';
            }
    /// ACTION comes from this form.
        } else {
            $actions = array("editquestions","reorderquestions","saveandreturn","general","cancelandreturn","addbreak","remove" ); 
            $action = '';
            foreach ($actions as $thisaction) {
                if ( array_key_exists($thisaction, $formdata) && $formdata->$thisaction ) {
                $action = $thisaction;
                    break;
                }
            }
            /// resetting $formdata->sid needed after previewing quiz because it gets "lost"! JR
            if ($formdata->sid == 0) {
                $formdata->sid = isset($SESSION->portfolio_survey_id) ? $SESSION->portfolio_survey_id : 0;
                $sid = $formdata->sid;
            }
        if ($action) {
            /// First make sure that all requirements have been met...
            if (isset($formdata->name)) {
                if (empty($formdata->title)) {
                    $formdata->title = $formdata->name;
                }                
            }
            $actions = array("editquestions","reorderquestions","saveandreturn","general","cancelandreturn","addbreak","remove"); 
            $action = '';
            foreach ($actions as $thisaction) {
                if ( array_key_exists($thisaction, $formdata) && $formdata->$thisaction ) {
                $action = $thisaction;
                    break;
                }
            }
            if ($action) {

            switch ($action) {
        
            case 'cancelandreturn':
                if (empty($instance)) {
                    $args = 'id='.$courseid.'&section='.$section.'&sesskey='.$USER->sesskey.'&add=portfolio';
                } else {
                    $args = 'update='.$cm->id.'&sesskey='.$USER->sesskey;
                }
                redirect($CFG->wwwroot.'/course/mod.php?'.$args);
                break;
        
            case 'saveandreturn':
                $tab = 'general';
                $qact = 'close';
                break;
        
            case 'general':
                $tab = 'general';
                $qact = 'edit';
                break;
        
            case 'editquestions':
            case 'remove':
                $tab = 'questions';
                $qact = 'equest';
                break;
        
            case 'reorderquestions':
            case 'addbreak':
                $tab = 'order';
                $qact = 'oquest';
                break;

            }
        }
                
            /// 'q' comes from the question editor as a submit, and can be from the reorder form.
            } else if (isset($formdata->q)) {
                if ($formdata->tab != 'questions') {
                    $formdata->tab = 'order'; 
                }
                if ( $formdata->tab == 'order' && empty($formdata->q) ) {
                    $tab = 'order';
                    $qact = 'oquest'; //order questions
                } else {
                    $tab = 'questions';
                    $qact = 'equest'; //edit questions
                }
            /// 'extra_choices' comes from the question editor as a submit.
            } else if (isset($formdata->extra_choices)) {
                $tab = 'questions';
                $qact = 'equest';
            } else if (isset($formdata->addbreak)) {
                $tab = 'order';
                $qact = 'oquest';
            } else if (isset($formdata->confirm)) {
                if ($formdata->confirm == 'Yes') {
                    set_field('portfolio_survey', 'status', STATUS_DELETED, 'id', $sid);
                }
                if (empty($instance)) {
                    $args = 'id='.$courseid.'&section='.$section.'&sesskey='.$USER->sesskey.'&add=portfolio';
                } else {
                    $args = 'update='.$cm->id.'&sesskey='.$USER->sesskey;
                }
                redirect($CFG->wwwroot.'/course/mod.php?'.$args);
            } else {
                $cancancel = true;
            }
            $SESSION->NEWQUESTION = false;
            $newquestion = false;
            if (isset($formdata->q) && ($formdata->q == get_string('newfield', 'portfolio')) ) {
                $newquestion = true;
                $SESSION->NEWQUESTION = true;
            }
            // save actual survey id to $tempsid because we only want to preview it

            $sid = $portfolio->survey_update($formdata->tab, $formdata, $newquestion);
            if ($sid === false) {
                $sid = 0;
                $updated = false;
            } else {
                $updated = true;
            }

        }
    /// Commands like 'new' may load the sid in the session.
        if (empty($sid) && !empty($SESSION->portfolio_survey_id)) {
            $sid = $SESSION->portfolio_survey_id;
        }

    } else {
        $cancancel = true;
    }
    $strportfolios = get_string("modulenameplural", "portfolio");
    if (isset($portfolio->name)) {
        $strname = ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$portfolio->cm->id.'">'.
            $portfolio->name.'</a>';
    } else {
        // new portfolio has a name but no id yet in moodle database
        $strname =   ' -> '.get_field('portfolio_survey', 'name', 'id', $tempsid);
    }
    if (portfolio_survey_has_questions($sid)) {
        $disabled = '';
    } else {
        $disabled = 'disabled="disabled"';
    }

    switch ($qact) {
/// close = portfolio editing is finished, we can close this editing session
    case 'close':
        $args = 'from=survey&sesskey='.$USER->sesskey.'&sid='.$formdata->sid;
        if (empty($instance)) {
            $args .= '&id='.$courseid.'&section='.$section.'&add=portfolio';
        } else {
            $args .= '&update='.$cm->id;
        }
        redirect($CFG->wwwroot.'/course/mod.php?'.$args);
        break;

    case 'preview':
        /// Print the page header
        /// Templates may not have portfolios yet...

        if (!isset($portfolio->name)) {
            $name = get_field('portfolio_survey', 'name', 'id', $tempsid);
            $portfolio->sid = $tempsid;
            $portfolio->add_questions($tempsid);
        } else {
            $name = $portfolio->name;
        }
        $qp = get_string('preview_portfolio', 'portfolio');
        $pq = get_string('previewing', 'portfolio');
        $currentcss = '';
        if ( !empty($portfolio->survey->theme) ) {
            $currentcss = '<link rel="stylesheet" type="text/css" href="'.
                $CFG->wwwroot.'/mod/portfolio/css/'.$portfolio->survey->theme.'" />';
        }
        print_header($c_obj->shortname.$qp,
                     $c_obj->fullname.$pq.$name, '', '', $currentcss, false);
    /// Print the main part of the page
        $SESSION->portfolio_survey_id = $tempsid;
        if (isset($formdata->sid) && $formdata->sid != 0) {
            $sid = $SESSION->portfolio_survey_id = $formdata->sid;
        } else {
            $sid = $SESSION->portfolio_survey_id;
        }
        $portfolio->survey = get_record('portfolio_survey', 'id', $sid);
        $n = count_records('portfolio_question', 'survey_id', $sid, 'type_id', '99', 'deleted', 'N');
        for ($i=1; $i<$n+2 ; $i++) {
            $portfolio->survey_render($i, '', $formdata);
        }
        close_window_button();
        echo '</div></div></body></html>';
        break;

/// DEPRECATED case delete WHAT? portfolio? questions ??? JR 13 APRIL 2007
    case 'delete':
    error ("case ************ delete DEPRECATED ??? *******************************");
        if (empty($portfolio->survey)) {
            error('Survey does not exist.');
        } else if ((int)$portfolio->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Print the page header
        print_header_simple(get_string('editingportfolio', 'portfolio'), '',
                 '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$c_obj->id.'">'.$strportfolios.
                 '</a> -> case delete '.get_string('editingsurvey', 'portfolio'));
    
    /// Print the main part of the page
    // JR replaced all name="phesp" with id="phesp" for XHTML strict validation
        echo '<form id="phpesp" method="post" action="manage_survey.php">';
        echo '<div>';
        echo '<input type="hidden" name="course" value="'.$courseid.'" />';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="sid" value="'.$sid.'" />';
        echo '<input type="hidden" name="section" value="'.$section.'" />';
        echo '<div class="headermain" align="center">Are you sure you want to delete survey: '.$surveyrec->name.'?<br /><br />';
        echo '<input type="submit" value="Yes" name="confirm" /> ';
        echo '<input type="submit" value="No" name="confirm" /> </div>';
        echo '</div>';
        echo '</form>';

        print_footer($c_obj);
        break;

    case 'copy':
        /// survey_copy needs the owner field set:
        if (empty($portfolio->survey)) {
            $portfolio->add_survey($sid);
            $portfolio->add_questions($sid);
        }
        $sid = $portfolio->sid = $portfolio->survey_copy($c_obj->id);
        /// Reload the new survey:
        $portfolio->add_survey($portfolio->sid);
        $portfolio->add_questions($portfolio->sid);
        
    /// Fall down into 'edit'.

    case 'edit':
        if (!($surveyrec = get_record_select('portfolio_survey', 'id = '.$sid, 'id,name,owner'))) {
            error('Survey does not exist.');
        } else if ((int)$surveyrec->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    case 'new':
    /// Print the page header
        print_header_simple(get_string('editingportfolio', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$c_obj->id.'">'.$strportfolios.'</a>'.
            $strname.
            ' -> '.get_string('editingportfolio', 'portfolio'));

        if (!empty($errstr)) {
            p($errstr);
        }

    /// Print the main part of the page
        echo '<form id="phpesp" method="post" action="manage_survey.php">';
        echo '<div>';
        echo '<input type="hidden" name="course" value="'.$courseid.'" />';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="sid" value="'.$sid.'" />';
        echo '<input type="hidden" name="section" value="'.$section.'" />';
        echo '<input type="hidden" name="tab" value="general" />';
        echo '</div>';

        echo '<hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.get_string('general', 'portfolio').'" name="general" disabled="disabled" />';
            helpbutton("general", get_string("general", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('editquestions', 'portfolio').'" name="editquestions" />';
            helpbutton("editquestions", get_string("editquestions", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('reorderquestions', 'portfolio').'" name="reorderquestions" '.$disabled.' />';
            helpbutton("reorderquestions", get_string("reorderquestions", "portfolio"), "portfolio", true, false);
        if ($cancancel) {
            echo '&nbsp;<input type="submit" value="'.get_string('return', 'portfolio').'" name="cancelandreturn" /> ';
        }
        echo '<input type="submit" value="'.get_string('saveandreturn', 'portfolio').'" name="saveandreturn" '.$disabled.' />';
            helpbutton("finish", get_string("saveandreturn", "portfolio"), "portfolio", true, false);
        echo '</div>';
        echo '<hr />';

        $updated = true;

        include 'general.inc';

        echo '<hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.get_string('general', 'portfolio').'" name="general" disabled="disabled" /> ';
        echo '<input type="submit" value="'.get_string('editquestions', 'portfolio').'" name="editquestions" /> ';
        echo '<input type="submit" value="'.get_string('reorderquestions', 'portfolio').'" name="reorderquestions" '.$disabled.' />';
        if ($cancancel) {
            echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="cancelandreturn" /> ';
        }
        echo '&nbsp;<input type="submit" value="'.get_string('saveandreturn', 'portfolio').'" name="saveandreturn" '.$disabled.' />';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        if ($portfolio->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;
        
    case 'equest':
        $qid = !empty($formdata->id) ? $formdata->id : 0;
        // if remove button has been clicked for current question: set deleted field to Y in database
        if (!empty($formdata->remove)) {
            if ($qid) {
                set_field('portfolio_question', 'deleted', 'Y', 'id', $qid, 'survey_id', $sid);
            }
        }
        if (empty($portfolio->survey)) {
//            error('Survey does not exist???');
/// this should never happen
        } else if ((int)$portfolio->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Print the page header
        print_header_simple(get_string('editingportfolio', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$c_obj->id.'">'.$strportfolios.'</a>'.
            $strname.
            ' -> '.get_string('editingsurvey', 'portfolio'));
    
        if (!empty($errstr)) {
            p($errstr);
        }
    /// Print the main part of the page
        echo '<form id="phpesp" method="post" action="manage_survey.php">';
        echo '<div>';
        echo '<input type="hidden" name="course" value="'.$courseid.'" />';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="sid" value="'.$sid.'" />';
        echo '<input type="hidden" name="section" value="'.$section.'" />';
        echo '<input type="hidden" name="tab" value="questions" />';
        echo '</div>';
        echo '<hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.get_string('general', 'portfolio').'" name="general" />';
            helpbutton("general", get_string("general", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('editquestions', 'portfolio').'"  name="editquestions" disabled="disabled"/>';
        helpbutton("editquestions", get_string("editquestions", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('reorderquestions', 'portfolio').'" name="reorderquestions" '.$disabled.' />';
            helpbutton("reorderquestions", get_string("reorderquestions", "portfolio"), "portfolio", true, false);
        echo '<input type="submit" value="'.get_string('saveandreturn', 'portfolio').'" name="saveandreturn" '.$disabled.' />';
            helpbutton("finish", get_string("saveandreturn", "portfolio"), "portfolio", true, false);
        echo '<hr />';
        $SESSION->portfolio_survey_id = $sid;
        include 'questions.inc';
        echo '<hr />';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        if ($portfolio->usehtmleditor) {
            use_html_editor();
        }
        print_footer($c_obj);
        break;
        
    case 'oquest':
        if (empty($portfolio->survey)) {
            error('Survey does not exist.');
        } else if ((int)$portfolio->survey->owner != $c_obj->id) {
            error('You must be a survey owner to perform this operation.');
        }

    /// Save  the tab in a session variablem to handle the reorder commands.
        $SESSION->portfolio_tab = 'order';

    /// Print the page header
        print_header_simple(get_string('editingportfolio', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$c_obj->id.'">'.$strportfolios.'</a>'.
            $strname.
            ' -> '.get_string('reorderingquestions', 'portfolio'));
    
        if (!empty($errstr)) {
            p($errstr);
        }

    /// Print the main part of the page
        echo '<form method="post" id="phpesp" action="manage_survey.php">';
        echo '<div>';
        echo '<input type="hidden" name="course" value="'.$courseid.'" />';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="sid" value="'.$sid.'" />';
        echo '<input type="hidden" name="section" value="'.$section.'" />';
        echo '<input type="hidden" name="tab" value="order" />';
        echo '</div>';

        echo '<hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.get_string('general', 'portfolio').'" name="general" />';
            helpbutton("general", get_string("general", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('editquestions', 'portfolio').'" name="editquestions" '.$disabled.' />';
            helpbutton("editquestions", get_string("editquestions", "portfolio"), "portfolio", true, false);
        echo '&nbsp;<input type="submit" value="'.get_string('reorderquestions', 'portfolio').'" name="reorderquestions" disabled="disabled" />';
            helpbutton("reorderquestions", get_string("reorderquestions", "portfolio"), "portfolio", true, false);
        if (!$disabled) {
            button_to_popup_window('/mod/portfolio/manage_survey.php?qact=preview&amp;instance='.$instance.'&amp;course='.$courseid.
                '&amp;sid='.$sid.'&amp;section='.$section, '', get_string('preview_label', 'portfolio'),0,0);            
            helpbutton("preview", get_string("preview_label", "portfolio"), "portfolio", true, false);
        }
        echo '<input type="submit" value="'.get_string('saveandreturn', 'portfolio').'" name="saveandreturn" '.$disabled.' />';
            helpbutton("finish", get_string("saveandreturn", "portfolio"), "portfolio", true, false);
        echo '</div>';
        echo '<hr />';

        $SESSION->portfolio_survey_id = $sid;
        $SESSION->portfolio_new_survey = false;
        include 'order.inc';

        echo '<hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.get_string('general', 'portfolio').'" name="general" /> ';
        echo '<input type="submit" value="'.get_string('editquestions', 'portfolio').'" name="editquestions" '.$disabled.' />';
        echo '<input type="submit" value="'.get_string('reorderquestions', 'portfolio').'" name="reorderquestions" disabled="disabled" /> ';
        if (!$disabled) {
        button_to_popup_window('/mod/portfolio/manage_survey.php?qact=preview&amp;instance='.$instance.'&amp;course='.$courseid.
                               '&amp;sid='.$sid.'&amp;section='.$section, '', get_string('preview_label', 'portfolio'),0,0);            
        }
        echo '<input type="submit" value="'.get_string('saveandreturn', 'portfolio').'" name="saveandreturn" '.$disabled.' />';
        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($c_obj);
        break;

     case 'unknown':
        default:
        $message = get_string('unknownaction', 'portfolio');
        if (empty($formdata)) {
            $message .= get_string('nodata', 'portfolio');
        } else {
            $message .= '<p>'.get_string('posteddata', 'portfolio').'</p>';
            $message .= '<pre>'.print_r($formdata, true).'</pre><br />';
        }
        error($message);
        break;
    }
?>