<?php  // $Id: myreport.php,v 1.2.8.2 2007/10/14 12:59:12 joseph_rezeau Exp $

/// This page shows results of a portfolio to a student.

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/portfolio/lib.php');

    $strsummary = get_string('summary', 'portfolio');
    $strall = get_string('myresponses', 'portfolio'); 
    $strviewbyresponse = get_string('viewbyresponse', 'portfolio');
    $strmodname = get_string('modulename', 'portfolio');
    $strmodnameplural = get_string('modulenameplural', 'portfolio');
    $strmyresults = get_string('myresults', 'portfolio');
    $strportfolios = get_string('modulenameplural', 'portfolio');

    $instance = required_param('instance', PARAM_INT);   // portfolio ID
    $userid = optional_param('user', $USER->id, PARAM_INT);
    $rid = optional_param('rid', false, PARAM_INT);
    $byresponse = optional_param('byresp', false, PARAM_INT);
    $action = optional_param('action', $strsummary, PARAM_RAW); // for languages utf-8 compatibility JR

    if (! $portfolio = get_record("portfolio", "id", $instance)) {
        error("portfolio is incorrect");
    }
    if (! $course = get_record("course", "id", $portfolio->course)) {
        error("Course is misconfigured");
    }
    if (! $cm = get_coursemodule_from_instance("portfolio", $portfolio->id, $course->id)) {
        error("Course Module ID was incorrect");
    }

    require_login($course->id);

    $portfolio = new portfolio(0, $portfolio, $course, $cm);

    switch ($action) {
    case $strsummary:
        if (empty($portfolio->survey)) {
            error('Survey does not exist.');
        }
        $select = 'survey_id = '.$portfolio->sid.' AND username = '.$userid.' AND complete=\'Y\'';
        $resps = get_records_select('portfolio_response', $select);
        $rids = array_keys($resps);
        $titletext = get_string('myresponsetitle', 'portfolio', count($resps));

    /// Print the page header
        print_header_simple(get_string('portfolioreport', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strmyresults);

        if (!empty($portfolio->survey->theme)) {
            $href = $CFG->wwwroot.'/mod/portfolio/css/'.$portfolio->survey->theme;
            echo '<script type="text/javascript" defer="defer">
                //<![CDATA[
                document.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"'.$href.'\">")
                //]]>
                </script>';     
        }   

        echo '<form method="post" action="myreport.php">';
        echo '<div>';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="user" value="'.$userid.'" />';
        echo '</div>';
        echo '<hr /><div style="text-align:center">';
        echo '<input type="submit" disabled="disabled" value="'.$strsummary.'" name="action" />';
        echo '<input type="submit" value="'.$strviewbyresponse.'" name="action" />';
        echo '<input type="submit" value="'.$strall.'" name="action" />';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" />';
        echo ('<hr />');
        echo('</div>');
        print_heading($titletext, 'center', '4');
        echo '<div class = "active">';

        $portfolio->survey_results(1, 1, '', '', $rids, '', $USER->id);
    
        echo '</div><hr />';
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.$strall.'" name="action" />';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" />';
    
        echo '</div>';
        echo '</form>';
        echo '</div>';
    /// Finish the page
        print_footer($course);
        break;

    case $strall:
        if (empty($portfolio->survey)) {
            error('Survey does not exist.');
        }
        $select = 'survey_id = '.$portfolio->sid.' AND username = '.$userid.' AND complete=\'Y\'';
        $resps = get_records_select('portfolio_response', $select);
        $titletext = get_string('myresponses', 'portfolio');

    /// Print the page header
        print_header_simple(get_string('portfolioreport', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strmyresults);
    
        echo '<form method="post" action="myreport.php">';
        echo '<div>';        
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="user" value="'.$userid.'" />';
        echo '<input type="hidden" name="byresp" value="1" />';
        echo '</div>';
        echo '<hr /><div style="text-align:center">';
        echo '<input type="submit" disabled="disabled" value="'.$strall.'" name="action" />';
        echo '<input type="submit" value="'.$strsummary.'" name="action" />';
        echo '<input type="submit" value="'.$strviewbyresponse.'" name="action" /> ';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" /> ';
        echo '<hr />';
        echo '</div>';
        print_heading($titletext.':', 'center', '4');

        echo '<table class = "active"><tr><td>';
        $portfolio->view_all_responses($resps);
        echo '</td></tr></table>';
        
        echo '<div style="text-align:center">';
        echo '<input type="submit" value="'.$strsummary.'" name="action" />';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" />';   
        echo '<hr /></div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;

    case $strviewbyresponse:
    case 'vresp':
        if (empty($portfolio->survey)) {
            error(get_string('surveynotexists', 'portfolio'));
        }
        $select = 'survey_id = '.$portfolio->sid.' AND username = '.$userid.' AND complete=\'Y\'';
        $resps = get_records_select('portfolio_response', $select);
        $rids = array_keys($resps);
        if (!$rid) {
            $rid = $rids[0];
        }
        if ($rid) {
            $titletext = '<strong>'.get_string('viewyourresponses', 'portfolio').'</strong>: ';
        }

    /// Print the page header
        print_header_simple(get_string('portfolioreport', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strmyresults);
   
        echo '<form method="post" action="myreport.php">';
        echo '<div>';
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="user" value="'.$userid.'" />';
        echo '</div>';
        echo '<hr /><div style="text-align:center">';
        echo '<input type="submit" disabled="disabled" value="'.$strviewbyresponse.'" name="action" />';
        echo '<input type="submit" value="'.$strsummary.'" name="action" />';
        echo '<input type="submit" value="'.$strall.'" name="action" />';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" />';
        echo '<hr />';
        echo '</div>';
        echo '<div style="text-align:center; padding-bottom:5px;">';
        echo ($titletext);
        $portfolio->survey_results_navbar_student ($rid, $userid, $instance, $resps);       
        echo '</div>';
        echo '<table class = "active"><tr><td>';
        $portfolio->view_response($rid);
        echo ('</td></tr></table>');

        echo '<div style="text-align:center">';
        echo get_string('viewyourresponses', 'portfolio').': ';

        $portfolio->survey_results_navbar_student ($rid, $userid, $instance, $resps);

        echo '<hr />';
        echo '<input type="submit" value="'.$strsummary.'" name="action" />';
        echo '<input type="submit" value="'.$strall.'" name="action" />';
        echo '<input type="submit" value="'.get_string('return', 'portfolio').'" name="action" />';
        echo '<hr /></div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;

    case get_string('return', 'portfolio'):
    default:
        redirect('view.php?id='.$cm->id);
    }
?>