<?php  // $Id: report.php,v 1.8.8.3 2007/10/14 16:56:31 joseph_rezeau Exp $

/// This page prints a particular instance of portfolio

    require_once("../../config.php");
    require_once($CFG->dirroot.'/mod/portfolio/lib.php');

    $instance = optional_param('instance', false, PARAM_INT);   // portfolio ID
    $qact = optional_param('qact', 'vresp');
    $sid = optional_param('sid', NULL, PARAM_INT);              // Survey id.
    $rid = optional_param('rid', false, PARAM_INT);
    $type = optional_param('type', '', PARAM_ALPHA);
    $byresponse = optional_param('byresponse', false, PARAM_INT);

    if ($instance === false) {
        if (!empty($SESSION->instance)) {
            $instance = $SESSION->instance;
        } else {
            error(get_string('requiredparameter', 'portfolio'));
        }
    }
    $SESSION->instance = $instance;

    if (! $portfolio = get_record("portfolio", "id", $instance)) {
        error(get_string('incorrectportfolio', 'portfolio'));
    }
    if (! $course = get_record("course", "id", $portfolio->course)) {
        error("get_string('misconfigured', 'portfolio')");
    }
    if (! $cm = get_coursemodule_from_instance("portfolio", $portfolio->id, $course->id)) {
        error(get_string('incorrectmodule', 'portfolio'));
    }

    require_login($course->id);

    if (!isteacheredit($course->id)) {
//        error(get_string('restrictedtoteacher', 'portfolio'));
    }

    $portfolio = new portfolio(0, $portfolio, $course, $cm);
    $formdata = data_submitted();

    $strcrossanalyze = get_string('crossanalyze', 'portfolio');
    $strcrosstabulate = get_string('crosstabulate', 'portfolio');
    $strdeleteallresponses = get_string('deleteallresponses', 'portfolio');
    $strdeleteresp = get_string('deleteresp', 'portfolio');
    $strdownloadcsv = get_string('downloadtext');
    $strviewallresponses = get_string('viewallresponses', 'portfolio');
    $strsummary = get_string('summary', 'portfolio');
    $strviewbyresponse = get_string('viewbyresponse', 'portfolio');
    $strportfolios = get_string('modulenameplural', 'portfolio');

    $actions = array("deleteresp","viewallresponses","viewbyresponse","crosstabulate",
        "cancelandreturn","downloadcsv","deleteallresponses");
    $action = '';
    if ($formdata) {
    foreach ($actions as $thisaction) {
        if ( array_key_exists($thisaction, $formdata) ) {
            $action = $thisaction;
            break;
        }
    }
        if ($action) {
            switch ($action) {
            case 'cancelandreturn':
                redirect($CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id);
                break;
        
            case 'viewallresponses':
                $qact = 'vresp';
                $byresponse = false;
                $rid = false;
                break;        
        
            case 'viewbyresponse':
                $qact = 'vresp';
                $byresponse = true;
                $rid = false;
                break;
        
            case 'crosstabulate':
                $qact = 'cross';
                break;
        
            case 'deleteresp':
                $qact = 'dresp';
                break;
        
            case 'downloadcsv':
                $qact = 'dcsv';
                break;

            case 'deleteallresponses':
                $qact = 'delallresp';
                break;
        
            default:
                redirect($CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id);
            }
        }
    }
   
    switch ($qact) {
  
    case 'dresp':
        if (empty($portfolio->survey)) {
            $id = $portfolio->survey;
            notify ("portfolio->survey = /$id/");

            error(get_string('surveynotexists', 'portfolio'));
        } else if ($portfolio->survey->owner != $course->id) {
            error(get_string('surveyowner', 'portfolio'));
        } else if (!$rid || !is_numeric($rid)) {
            error(get_string('invalidresponse', 'portfolio'));
        } else if (!($resp = get_record('portfolio_response', 'id', $rid))) {
            error(get_string('invalidresponserecord', 'portfolio'));
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- '.get_string('unknown', 'portfolio').' -';
            }
        } else {
            $ruser = $resp->username;
        }

    /// Print the page header
        print_header_simple(get_string('deletingresp', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strviewallresponses);

        notice_yesno(get_string('confirmdelresp', 'portfolio', $ruser),
            $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;rid='.$rid.'&amp;qact=dvresp',
            $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;rid='.$rid);

    /// Finish the page
        print_footer($course);
        break;
        
    case 'delallresp': // JR
        $select = 'survey_id='.$sid.' AND complete = \'Y\'';
        if (!($responses = get_records_select('portfolio_response', $select, 'id', 'id'))) {
            return;
        }
        foreach($responses as $rid=>$valeur) {
            break;
        } 
        if (empty($portfolio->survey)) {
            $id = $portfolio->survey;
            notify ("portfolio->survey = /$id/");
            error(get_string('surveynotexists', 'portfolio'));
        } else if ($portfolio->survey->owner != $course->id) {
            error(get_string('surveyowner', 'portfolio'));
        } else if (!$rid || !is_numeric($rid)) {
            error(get_string('invalidresponse', 'portfolio'));
        } else if (!($resp = get_record('portfolio_response', 'id', $rid))) {
            error(get_string('invalidresponserecord', 'portfolio'));
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- '.get_string('unknown', 'portfolio').' -';
            }
        } else {
            $ruser = $resp->username;
        }

    /// Print the page header
        print_header_simple(get_string('deletingresp', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strviewallresponses);

        notice_yesno(get_string('confirmdelallresp', 'portfolio'),
                $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;rid='.$rid.'&amp;qact=dvallresp',
                $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;rid='.$rid);
        echo '</div>';
    /// Finish the page
        print_footer($course);
        break;
        
    case 'dvresp':

        if (empty($portfolio->survey)) {
            error(get_string('surveynotexists', 'portfolio'));
        } else if ($portfolio->survey->owner != $course->id) {
            error(get_string('surveyowner', 'portfolio'));
        } else if (!$rid || !is_numeric($rid)) {
            error(get_string('invalidresponse', 'portfolio'));
        } else if (!($resp = get_record('portfolio_response', 'id', $rid))) {
            error(get_string('invalidresponserecord', 'portfolio'));
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- '.get_string('unknown', 'portfolio').' -';
            }
        } else {
            $ruser = $resp->username;
        }


    /// Print the page header
        print_header_simple(get_string('deletingresponse', 'portfolio'), '',
                 '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.
                 '</a> -> '.'Survey Reports');
        if (portfolio_delete_response($rid)) {
            redirect($CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;byresponse=1',
                get_string('deletedresp', 'portfolio').$rid.get_string('by', 'portfolio').$ruser.'.', 0);
        } else {
            error (get_string('couldnotdelresp', 'portfolio').$rid.get_string('by', 'portfolio').$ruser.'?',
                   $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;byresponse=1');
        }
        break;

    case 'dvallresp':

        if (empty($portfolio->survey)) {
            error(get_string('surveynotexists', 'portfolio'));
        } else if ($portfolio->survey->owner != $course->id) {
            error(get_string('surveyowner', 'portfolio'));
        } else if (!$rid || !is_numeric($rid)) {
            error(get_string('invalidresponse', 'portfolio'));
        } else if (!($resp = get_record('portfolio_response', 'id', $rid))) {
            error(get_string('invalidresponserecord', 'portfolio'));
        }

        $ruser = false;
        if (is_numeric($resp->username)) {
            if ($user = get_record('user', 'id', $resp->username)) {
                $ruser = fullname($user);
            } else {
                $ruser = '- '.get_string('unknown', 'portfolio').' -';
            }
        } else {
            $ruser = $resp->username;
        }

    /// Print the page header
        print_header_simple(get_string('deletingresponse', 'portfolio'), '',
                 '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.
                 '</a> -> '.'Survey Reports');

    /// Delete all responses for the survey:
            if ($responses = get_records('portfolio_response', 'survey_id', $sid, 'id')) {
                foreach ($responses as $response) {
                    portfolio_delete_response($response->id);
                }
                redirect($CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id, get_string('deletedallresp', 'portfolio'), 0);
            } else {
            error (get_string('couldnotdelresp', 'portfolio').$rid.get_string('by', 'portfolio').$ruser.'?',
                   $CFG->wwwroot.'/mod/portfolio/report.php?where=results&amp;sid='.$sid.'&amp;byresponse=1');
        }

        break;
        
    case 'dcsv':
        include 'download.inc';
        exit();
        break;        

    case 'cross':
        $type = 'cross';
        /// Fall down into the vresp section.

    case 'vresp':
    default:
        if (empty($portfolio->survey)) {
            error(get_string('surveynotexists', 'portfolio'));
        } else if ($portfolio->survey->owner != $course->id) {
            error(get_string('surveyowner', 'portfolio'));
        }

        $ruser = false;

        if ($byresponse || $rid) { 
            if ($rid === false) {
                $resps = get_records('portfolio_response', 'survey_id', $sid, 'id', '*', 0, 1);
                $resp = current($resps);
                $rid = $resp->id;
            } else {
                $resp = get_record('portfolio_response', 'id', $rid);
            }
            if (is_numeric($resp->username)) {
                if ($user = get_record('user', 'id', $resp->username)) {
                    $ruser = fullname($user);
                } else {
                $ruser = '- '.get_string('unknown', 'portfolio').' -';
                }
            } else {
                $ruser = $resp->username;
            }
        }

    /// Print the page header
        print_header_simple(get_string('portfolioreport', 'portfolio'), '',
            '<a href="'.$CFG->wwwroot.'/mod/portfolio/index.php?id='.$course->id.'">'.$strportfolios.'</a>'.
            ' -> '.'<a href="'.$CFG->wwwroot.'/mod/portfolio/view.php?id='.$cm->id.'">'.$portfolio->name.'</a>'.
            ' -> '.get_string('portfolioreport', 'portfolio').
            ' -> '.$strviewallresponses);
            
        if (!empty($portfolio->survey->theme)) {
            $href = $CFG->wwwroot.'/mod/portfolio/css/'.$portfolio->survey->theme;
            echo '<script type="text/javascript" defer="defer">
                //<![CDATA[
                document.write("<link rel=\"stylesheet\" type=\"text/css\" href=\"'.$href.'\">")
                //]]>
                </script>';     
        }   

    /// Print the main part of the page

        echo '<form method="post" action="report.php">';
        echo ('<div>');
        echo '<input type="hidden" name="instance" value="'.$instance.'" />';
        echo '<input type="hidden" name="sid" value="'.$sid.'" />';
        echo '<input type="hidden" name="tab" value="general" />';
        echo ('</div>');

        echo '<hr /><div style="text-align:center">';
        if ($rid) {
            echo '<input type="hidden" name="rid" value="'.$rid.'" />';
            echo '<input type="submit" disabled="disabled" value="'.$strviewbyresponse.'" />';
            // open print friendly as popup window to fix XML strict bug contrib-200
            $linkname = get_string('print','portfolio');
            $title = get_string('printtooltip','portfolio');
            $url = '/mod/portfolio/print.php?qid='.$portfolio->id.'&amp;rid='.$rid.'&amp;courseid='.$course->id.'&amp;sec=1';
            $print = button_to_popup_window($url, '', $linkname,'' ,'' , $title, '', false);
            echo($print);           
            echo '<input type="submit" name="deleteresp" value="'.$strdeleteresp.'" />';
            echo '<input type="submit" name="viewallresponses" value="'.$strsummary.'" />';
        } else {
            echo '<input type="submit" disabled="disabled" value="'.$strsummary.'" />';
            if (isteacher($course->id)) {
//                echo '<input type="submit" name="deleteallresponses" value="'.$strdeleteallresponses.'" />';
                echo '<input type="submit" name="viewbyresponse" value="'.$strviewbyresponse.'" />';
            }
        }
        echo '<input type="submit" name="cancelandreturn" value="'.get_string('return', 'portfolio').'" />';          
        echo '</div>';

        echo '<hr />';

        if (!$rid) {
                echo '<div style="text-align:center">';
                $resp = count_records('portfolio_response', 'survey_id', $sid);
                $titletext = get_string('responses', 'portfolio');
                echo $resp.' '.get_string('responses', 'portfolio');
                echo '</div>';            
        }

        $SESSION->portfolio_survey_id = $sid;
        include 'results.inc';
        echo '<div style="text-align:center">';
        if (!$rid && isteacher($course->id)) {
            echo '<input type="submit" name="downloadcsv" value="'.$strdownloadcsv.'" />';
            helpbutton("downloadtextformat", $strdownloadcsv, "portfolio", true, false);            
        }
        echo '<input type="submit" name="cancelandreturn" value="'.get_string('return', 'portfolio').'" />';

        echo '</div>';
        echo '</form>';
    
    /// Finish the page
        print_footer($course);
        break;
    }
?>